leetcode hot100 11.盛最多水的容器 medium 双指针

暴力 O(n²)

超时

python 复制代码
class Solution:
    def maxArea(self, height: List[int]) -> int:

        maxwater = 0
        for i in range(len(height)):
            for j in range (i, len(height)):
                area = (j-i) * min(height[i], height[j])
                maxwater = max(maxwater,area)

        return maxwater      
        

丢掉短板

保留长板

首尾双指针 left, right = 0, len(height) - 1

两边指针向里收缩,当 left ≥ right,停止

面积 = 底× 高,收缩过程中,底在减小,只有高会变化:

min(height[i], height[j])

假设现在 height[i] < height[j]
min(height[i], height[j]) = height[i]

假设下一根柱子的高度K,

如果移动高的那一边,矮高被保留
height[i] < height[j] < K ,矩形高度仍然为heighti,底宽减小,最大水量比原来小
height[i] < K < height[j] ,矩形高度仍然为heighti,底宽减小,最大水量比原来小
K < height[i] < height[j] ,矩形高度变为K,底宽减小,最大水量比原来小

如果移动低的那一边,矮高被丢弃
height[i] < height[j] < K , 矮高已被丢弃,矩形高度变为heightj , heightj > 原来的heighti ,底宽减小,最大水量有机会变大
height[i] < K < height[j] ,矮高已被丢弃,矩形高度变为K ,K > 原来的heighti ,底宽减小,最大水量有机会变大
K < height[i] < height[j] ,矮高已被丢弃,矩形高度变为K ,K < 原来的heighti ,底宽减小,最最大水量比原来小

所以应该移动低的那一边

python 复制代码
class Solution:
    def maxArea(self, height: List[int]) -> int:

        maxwater = 0
        i =0 
        j = len(height)-1
        while i<j:
            area = (j-i) * min(height[i], height[j])
            maxwater = max(maxwater,area)

            if height[i] < height[j]:
                i+=1
            else:
                j-=1


        return maxwater      
相关推荐
longlongzihan13 小时前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
封印师请假去地球钓鱼13 小时前
边解边变的问题:从“决策依赖“一词出发
人工智能·算法
今晚打老虎14 小时前
c++之提高A(前缀和)(第三课)
数据结构·c++·算法
财情双生教练易和中14 小时前
“找矿大会战”产业链,量化统计研究报告
职场和发展·职业发展·创业创新·程序员创富
不会就选b15 小时前
算法日常・每日刷题--<贪心>26
数据结构·算法
yuanxi20015 小时前
001267拟扩产光模块:大客户销售如何用价值力读一条扩产公告
人工智能·职场和发展·创业创新·学习方法
Interview Aid11216 小时前
Google SWE Intern Interview Process:OA、Coding 与面试流程详解
面试·职场和发展
hetao173383716 小时前
2026-09-29 hetao1733837 的刷题记录
c++·算法
欣欣之王来了17 小时前
AI合规专项:AI算法透明度的合规要求
人工智能·算法
wzdark17 小时前
分块思想在算法优化中的实践与应用4
算法